/*
 * Go2PartHoleX.c
 * 
 * Gocator system communication library
 * Copyright (C) 2013 by LMI Technologies Inc.
 * 
 * Licensed under The MIT License.
 * Redistributions of files must retain the above copyright notice.
 */

#include <z/Go2Measurements/zGo2PartHoleX.h>
#include <z/zGo2PartTypes.h>
#include <z/zGo2System.h>
#include <string.h>

/*
 * Go2PartHoleX Class 
 */

GO2_EXPORT(Go2Status) Go2PartHoleX_Construct(Go2PartHoleX* measurement, Go2UInt32 id, Go2Object system)
{
    Go2PartHoleX output = zNIL; 
    Go2Status status = zOK; 

    zCHECK(zCalloc(&output, 1, sizeof(Go2PartHoleXClass))); 

    if (!zSUCCESS(status = Go2PartHoleX_Init(output, id, system)))
    {
        zCHECK(Go2Object_Destroy(output)); 
        return status; 
    }

    *measurement = output; 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_Init(Go2PartHoleX measurement, Go2UInt32 id, Go2Object system)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    zCHECK(Go2PartMeasurement_Init(measurement, GO2_TYPE_PART_HOLE_X, id, system)); 

    obj->Release = Go2PartHoleX_VRelease;
    obj->Read = Go2PartHoleX_VRead; 
    obj->Write = Go2PartHoleX_VWrite; 

    obj->nominalRadius = 10.0;
    obj->radiusTolerance = 1.0;
    obj->partialDetectionEnabled = GO2_FALSE;

    for (i = 0; i < zCOUNT(obj->refRegions); ++i)
    {
        zCHECK(Go2PartRegion2d_Construct(&obj->refRegions[i], system));
    }
    //construct all ref areas, but initialize the measurement to only use 2
    obj->refRegionCount = 2;

    obj->refRegionsEnabled = GO2_FALSE;
    obj->autoRefRegionEnabled = GO2_TRUE;
    obj->autoTiltCorrectionEnabled = GO2_TRUE;
    obj->tiltXAngle = 0.0;
    obj->tiltYAngle = 0.0;

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_VRelease(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    z32u i; 

    for (i = 0; i < zCOUNT(obj->refRegions); ++i)
    {
        zCHECK(Go2Object_Destroy(obj->refRegions[i])); 
    }

    zCHECK(Go2PartMeasurement_VRelease(measurement));  
        
    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_VRead(Go2PartHoleX measurement, zXml xml, zXmlItem item)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    zXmlItem regionItem = zNIL;

    zCHECK(Go2PartMeasurement_VRead(measurement, xml, item)); 

    obj->refRegionCount = 0; 
    
    //ensure we at least have one refArea
    zCHECK(!zIS_NIL(regionItem = zXml_Child(xml, item, "RefRegions/RefRegion")));     
    while (!zIS_NIL(regionItem))
    {
        zCHECK(Go2PartRegion2d_Read(obj->refRegions[obj->refRegionCount], xml, regionItem));  
        obj->refRegionCount++;  
        regionItem = zXml_NextSibling(xml, regionItem);
    }
    
    zCHECK(zXml_Child64f(xml, item, "NominalRadius", &obj->nominalRadius)); 
    zCHECK(zXml_Child64f(xml, item, "RadiusTolerance", &obj->radiusTolerance)); 
    zCHECK(zXml_Child32s(xml, item, "PartialDetectionEnabled", &obj->partialDetectionEnabled)); 

    zCHECK(zXml_Child32s(xml, item, "RefRegionsEnabled", &obj->refRegionsEnabled));
    zCHECK(zXml_Child32s(xml, item, "AutoRefRegionEnabled", &obj->autoRefRegionEnabled));
    zCHECK(zXml_Child32s(xml, item, "AutoTiltCorrectionEnabled", &obj->autoTiltCorrectionEnabled));
    zCHECK(zXml_Child64f(xml, item, "TiltXAngle", &obj->tiltXAngle)); 
    zCHECK(zXml_Child64f(xml, item, "TiltYAngle", &obj->tiltYAngle)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_VWrite(Go2PartHoleX  measurement, zXml xml, zXmlItem item)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    zXmlItem regionItem = zNIL;
    zXmlItem refRegionItem = zNIL;
    z32u i; 

    zCHECK(Go2PartMeasurement_VWrite(measurement, xml, item)); 

    zCHECK(zXml_AddItem(xml, item, "RefRegions", &refRegionItem));  
    for (i = 0; i < obj->refRegionCount; ++i)
    {
        zCHECK(zXml_AddItem(xml, refRegionItem, "RefRegion", &regionItem)); 
        zCHECK(Go2PartRegion2d_Write(obj->refRegions[i], xml, regionItem)); 
    }

    zCHECK(zXml_SetChild64f(xml, item, "NominalRadius", obj->nominalRadius)); 
    zCHECK(zXml_SetChild64f(xml, item, "RadiusTolerance", obj->radiusTolerance)); 
    zCHECK(zXml_SetChild32s(xml, item, "PartialDetectionEnabled", obj->partialDetectionEnabled)); 

    zCHECK(zXml_SetChild32s(xml, item, "RefRegionsEnabled", obj->refRegionsEnabled)); 
    zCHECK(zXml_SetChild32s(xml, item, "AutoRefRegionEnabled", obj->autoRefRegionEnabled)); 
    zCHECK(zXml_SetChild32s(xml, item, "AutoTiltCorrectionEnabled", obj->autoTiltCorrectionEnabled)); 
    zCHECK(zXml_SetChild64f(xml, item, "TiltXAngle", obj->tiltXAngle)); 
    zCHECK(zXml_SetChild64f(xml, item, "TiltYAngle", obj->tiltYAngle)); 

    return GO2_OK; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetId(Go2PartHoleX measurement, Go2UInt32 id)
{
    return Go2Measurement_SetId(measurement, id); 
}

GO2_EXPORT(Go2UInt32) Go2PartHoleX_Id(Go2PartHoleX measurement)
{
    return Go2Measurement_Id(measurement); 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetName(Go2PartHoleX measurement, const Go2Char* name)
{
    return Go2Measurement_SetName(measurement, name); 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_Name(Go2PartHoleX measurement, Go2Char* name, Go2UInt32 capacity)
{
    return Go2Measurement_Name(measurement, name, capacity); 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetDecisionMin(Go2PartHoleX measurement, Go2Double min)
{
    return Go2Measurement_SetDecisionMin(measurement, min); 
}

GO2_EXPORT(Go2Double) Go2PartHoleX_DecisionMin(Go2PartHoleX measurement)
{
    return Go2Measurement_DecisionMin(measurement); 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetDecisionMax(Go2PartHoleX measurement, Go2Double max)
{
    return Go2Measurement_SetDecisionMax(measurement, max); 
}

GO2_EXPORT(Go2Double) Go2PartHoleX_DecisionMax(Go2PartHoleX measurement)
{
    return Go2Measurement_DecisionMax(measurement); 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableHold(Go2PartHoleX measurement, Go2Bool enable)
{
    return Go2Measurement_EnableHold(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2PartHoleX_HoldEnabled(Go2PartHoleX measurement)
{
    return Go2Measurement_HoldEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableSmoothing(Go2PartHoleX measurement, Go2Bool enable)
{
    return Go2Measurement_EnableSmoothing(measurement, enable);  
} 

GO2_EXPORT(Go2Bool) Go2PartHoleX_SmoothingEnabled(Go2PartHoleX measurement)
{
    return Go2Measurement_SmoothingEnabled(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleX_SmoothingWindowMin(Go2PartHoleX measurement)
{
    return Go2Measurement_SmoothingWindowMin(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleX_SmoothingWindowMax(Go2PartHoleX measurement)
{
    return Go2Measurement_SmoothingWindowMax(measurement);  
} 

GO2_EXPORT(Go2Status) Go2PartHoleX_SetSmoothingWindow(Go2PartHoleX measurement, Go2UInt32 window)
{
    return Go2Measurement_SetSmoothingWindow(measurement, window);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleX_SmoothingWindow(Go2PartHoleX measurement)
{
    return Go2Measurement_SmoothingWindow(measurement);  
} 

GO2_EXPORT(Go2UInt32) Go2PartHoleX_RefRegionCount(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 
    return obj->refRegionCount;      
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetRefRegionCount(Go2PartHoleX measurement, Go2UInt32 count)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 
    Go2Status status = GO2_OK;

    if(count > zCOUNT(obj->refRegions)){
        return GO2_ERROR_PARAMETER;
    }
    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    status = Go2System_Set32u(obj->system, &obj->refRegionCount, count, 1, GO2_MAX_REF_REGIONS); 
    zCHECK(Go2System_SetModified(obj->system)); 

    return status;      
}

GO2_EXPORT(Go2PartRegion2d) Go2PartHoleX_RefRegionAt(Go2PartHoleX measurement, Go2UInt32 index)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 
    return obj->refRegions[index];      
}

GO2_EXPORT(Go2Double) Go2PartHoleX_NominalRadius(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 
    return obj->nominalRadius;      
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetNominalRadius(Go2PartHoleX measurement, Go2Double radius)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->nominalRadius, radius, 0.0, z64F_MAX);        
}

GO2_EXPORT(Go2Double) Go2PartHoleX_RadiusTolerance(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 
    return obj->radiusTolerance;      
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetRadiusTolerance(Go2PartHoleX measurement, Go2Double tolerance)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->radiusTolerance, tolerance, 0.0, z64F_MAX);     
}

GO2_EXPORT(Go2Bool) Go2PartHoleX_AutoRefRegionEnabled(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    return obj->autoRefRegionEnabled; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableAutoRefRegion(Go2PartHoleX measurement, Go2Bool enable)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->autoRefRegionEnabled = enable; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK;
}

GO2_EXPORT(Go2Bool) Go2PartHoleX_AutoTiltCorrectionEnabled(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    return obj->autoTiltCorrectionEnabled; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableAutoTiltCorrection(Go2PartHoleX measurement, Go2Bool enable)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->autoTiltCorrectionEnabled = enable; 
    zCHECK(Go2System_SetModified(obj->system)); 

    return GO2_OK;
}

GO2_EXPORT(Go2Double) Go2PartHoleX_TiltXAngle(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    return obj->tiltXAngle; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetTiltXAngle(Go2PartHoleX measurement, Go2Double tiltXAngle)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->tiltXAngle, tiltXAngle, -z64F_MAX, z64F_MAX);   
}

GO2_EXPORT(Go2Double) Go2PartHoleX_TiltYAngle(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);
    return obj->tiltYAngle; 
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetTiltYAngle(Go2PartHoleX measurement, Go2Double tiltYAngle)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 

    return Go2System_Set64f(obj->system, &obj->tiltYAngle, tiltYAngle, -z64F_MAX, z64F_MAX);   
}

GO2_EXPORT(Go2Bool) Go2PartHoleX_PartialDetectionEnabled(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 

    return obj->partialDetectionEnabled;
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnablePartialDetection(Go2PartHoleX measurement, Go2Bool enable)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement); 

    zCHECK(Go2System_CheckConfigurable(obj->system));
    obj->partialDetectionEnabled = enable;
    zCHECK(Go2System_SetModified(obj->system));
    
    return GO2_OK;
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetScale(Go2PartHoleX measurement, Go2Double scale){
    return Go2Measurement_SetScale(measurement, scale);
}

GO2_EXPORT(Go2Double) Go2PartHoleX_Scale(Go2PartHoleX measurement){
    return Go2Measurement_Scale(measurement);
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetOffset(Go2PartHoleX measurement, Go2Double offset){
    return Go2Measurement_SetOffset(measurement, offset);
}

GO2_EXPORT(Go2Double) Go2PartHoleX_Offset(Go2PartHoleX measurement){
    return Go2Measurement_Offset(measurement);
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableLink(Go2PartHoleX measurement, Go2Bool enable)  
{
    return Go2Measurement_EnableLink(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2PartHoleX_LinkEnabled(Go2PartHoleX measurement)  
{
    return Go2Measurement_LinkEnabled(measurement);  
}

GO2_EXPORT(Go2Status) Go2PartHoleX_SetLink(Go2PartHoleX measurement, Go2UInt32 link) 
{
    return Go2Measurement_SetLink(measurement, link); 
}

GO2_EXPORT(Go2UInt32) Go2PartHoleX_Link(Go2PartHoleX measurement) 
{
    return Go2Measurement_Link(measurement); 
}

GO2_EXPORT(Go2PartRegion3d) Go2PartHoleX_Region(Go2PartHoleX measurement)
{
    return Go2PartMeasurement_Region(measurement);
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableRegion(Go2PartHoleX measurement, Go2Bool enable)  
{
    return Go2PartMeasurement_EnableRegion(measurement, enable);  
}

GO2_EXPORT(Go2Bool) Go2PartHoleX_RegionEnabled(Go2PartHoleX measurement)  
{
    return Go2PartMeasurement_RegionEnabled(measurement);  
}

GO2_EXPORT(Go2Bool) Go2PartHoleX_RefRegionsEnabled(Go2PartHoleX measurement)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);

    return obj->refRegionsEnabled;
}

GO2_EXPORT(Go2Status) Go2PartHoleX_EnableRefRegions(Go2PartHoleX measurement, Go2Bool enable)
{
    Go2PartHoleXClass* obj = zHANDLE_POINTER(measurement);

    zCHECK(Go2System_CheckConfigurable(obj->system)); 
    obj->refRegionsEnabled = enable;
    zCHECK(Go2System_SetModified(obj->system));

    return GO2_OK;
}

GO2_EXPORT(Go2UInt32) Go2PartHoleX_LinkOptionCount(Go2PartHoleX measurement)
{
    return Go2Measurement_LinkOptionCount(measurement);
}

GO2_EXPORT(Go2UInt32) Go2PartHoleX_LinkOptionAt(Go2PartHoleX measurement, Go2UInt32 index)
{
    return Go2Measurement_LinkOptionAt(measurement, index);
}
